---
title: Export web and API operations as OpenAPI schemas
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[API Gateway](https://developers.cloudflare.com/api/go/resources/api_gateway)

[Schemas](https://developers.cloudflare.com/api/go/resources/api_gateway/subresources/schemas)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Export web and API operations as OpenAPI schemas

client.APIGateway.Schemas.List(ctx, params) (\*[SchemaListResponse](<https://developers.cloudflare.com/api/go/resources/api_gateway#(resource)%20api_gateway.schemas%20%3E%20(model)%20SchemaListResponse%20%3E%20(schema)>), error)

GET/zones/{zone\_id}/api\_gateway/schemas

Returns tracked web and API operations and their feature configuration rendered as OpenAPI schemas.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account API Gateway``Account API Gateway Read``Domain API Gateway``Domain API Gateway Read`

##### ParametersExpand Collapse

<details>

<summary>

params SchemaListParams

</summary>

ZoneID param.Field\[string]

Path param: Identifier.

maxLength32

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

Feature param.Field\[\[]SchemaListParamsFeature]Optional

Query param: Add feature(s) to the results. The feature name that is given here corresponds to the resulting feature object. Have a look at the top-level object description for more details on the specific meaning.

</summary>

const SchemaListParamsFeatureThresholds SchemaListParamsFeature = "thresholds"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%200">Link to this property</a>

const SchemaListParamsFeatureParameterSchemas SchemaListParamsFeature = "parameter\_schemas"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%201">Link to this property</a>

const SchemaListParamsFeatureSchemaInfo SchemaListParamsFeature = "schema\_info"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%202">Link to this property</a>

const SchemaListParamsFeatureConfidenceIntervals SchemaListParamsFeature = "confidence\_intervals"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature">Link to this property</a>

Host param.Field\[\[]string]Optional

Query param: Receive schema only for the given host(s).

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20host">Link to this property</a>

<details>

<summary>

IncludeSchemaKind param.Field\[\[]SchemaListParamsIncludeSchemaKind]Optional

Query param: Schema kinds to include in exported OpenAPI schemas.

</summary>

const SchemaListParamsIncludeSchemaKindLearned SchemaListParamsIncludeSchemaKind = "learned"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20include_schema_kind%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%200">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20include_schema_kind">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type SchemaListResponse struct{…}

</summary>

Schemas \[]unknownOptional

<a href="#(resource)%20api_gateway.schemas%20%3E%20(model)%20SchemaListResponse%20%3E%20(schema)%20%3E%20(property)%20schemas">Link to this property</a>

Timestamp stringOptional

<a href="#(resource)%20api_gateway.schemas%20%3E%20(model)%20SchemaListResponse%20%3E%20(schema)%20%3E%20(property)%20timestamp">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.schemas%20%3E%20(model)%20SchemaListResponse%20%3E%20(schema)>)

### Export web and API operations as OpenAPI schemas

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/api_gateway"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  schemas, err := client.APIGateway.Schemas.List(context.TODO(), api_gateway.SchemaListParams{
    ZoneID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", schemas.Schemas)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schemas": [
      {
        "info": {
          "title": "OpenAPI JSON schema for www.example.com",
          "version": "1.0"
        },
        "openapi": "3.0.0",
        "paths": {
          "... Further paths ...": {},
          "/api/v1/users/{var1}": {
            "get": {
              "parameters": [
                {
                  "name": "var1",
                  "in": "path",
                  "required": true,
                  "schema": {
                    "type": "string"
                  }
                }
              ]
            }
          }
        },
        "servers": [
          {
            "url": "www.example.com"
          }
        ]
      }
    ],
    "timestamp": "timestamp"
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schemas": [
      {
        "info": {
          "title": "OpenAPI JSON schema for www.example.com",
          "version": "1.0"
        },
        "openapi": "3.0.0",
        "paths": {
          "... Further paths ...": {},
          "/api/v1/users/{var1}": {
            "get": {
              "parameters": [
                {
                  "name": "var1",
                  "in": "path",
                  "required": true,
                  "schema": {
                    "type": "string"
                  }
                }
              ]
            }
          }
        },
        "servers": [
          {
            "url": "www.example.com"
          }
        ]
      }
    ],
    "timestamp": "timestamp"
  },
  "success": true
}
```